/***************************************************************************\
*****************************************************************************
**                                                                         **
** header file:    common.h                                                **
** last revision:  28/03/2004                                              **
**                                                                         **
*****************************************************************************
*****************************************************************************
**                                                                         **
** This program is free software; you can redistribute it and/or modify it **
** under the terms of the GNU General Public License as published by the   **
** Free Software Foundation; either version 2, or (at your option) any     **
** later version.                                                          **
**                                                                         **
** This program is distributed in the hope that it will be useful,         **
** but WITHOUT ANY WARRANTY; without even the implied warranty of          **
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           **
** GNU General Public License for more details.                            **
**                                                                         **
** You should have received a copy of the GNU General Public License       **
** along with this program; if not, write to the Free Software             **
** Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.                     **
**                                                                         **
*****************************************************************************
\***************************************************************************/

//---------------------------------------------------------------------------------------
//|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
//---------------------------------------------------------------------------------------

#ifndef __COMMON_H__
#define __COMMON_H__

#define PROGRAM_NAME "SFT"
#define PROGRAM_VERSION "0.4.14"
#define PROGRAM_AUTHORS "Nicolas BENOIT (nbenoit@tuxfamily.org)"

#define STR_CONFIRM  "#OK\n"
#define STR_LIMIT    "+Bytes Limit Exceeded, Bye Bye!\n"
#define STR_TOO_LONG "+File Listing Is Too Long...\n"
#define STR_STOP     "+An Error Occured On My Side, Bye Bye!\n"
#define STR_QUIT     "#Bye Bye!\n"

#define DIAL_BUFFER_SIZE 0x400
#define FILE_BUFFER_SIZE 0x10000

#ifndef ARG_MAX
#define LISTING_MAX_SIZE 32767
#else
#define LISTING_MAX_SIZE ARG_MAX
#endif

#define TIME_OUT 5

struct file_t
{
  char *name;      // The Name Of The File
  char *path;      // The Path Of The File
  char *full_name; // The Name Of The File Including The Path
  size_t size;     // The Size Of The File
  long checksum;   // The Checksum Of The File
};

struct options_t
{
  char mode;               // The Mode (s = server, c = client)
  int port;                // The Port We Have To Use (both sides)
  char *dir;               // The Working Directory (both sides)
  char keep_running;       // Are We Going To Keep The Server Up? (server side only)
  long int limit;          // The Maximum Amount Of Data We Can Receive (server side only)
  char *address;           // The Host Adress (client side only)
  struct file_t *file;     // The Files We Have To Send (client side only)
  int nbr_files;           // The Number Of Files (client side only)
};

#endif

//---------------------------------------------------------------------------------------
//|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
//---------------------------------------------------------------------------------------
