/* -*- Mode: C; tab-width: 2; indent-tabs-mode: t; c-basic-offset: 2 -*-
 * File: dns.h
 *
 * Created: Mon May 19 10:20:00 2003
 *
 * $Id: dns.h,v 1.1 2003/12/13 20:59:15 mhassler Exp $
 */

#ifndef _DNS_H_
#define _DNS_H_

#include <endian.h>

#define NAMESERVER	0x7F000001 // 127.0.0.1
//#define NAMESERVER	0x9EDA6C15 // 158.218.108.21
//#define NAMESERVER	0xC0A87703 // 192.168.119.3

struct dns_header
{
	unsigned int id : 16;

#if __BYTE_ORDER == __LITTLE_ENDIAN
	unsigned int rd : 1;
	unsigned int tc : 1;
	unsigned int aa : 1;
	unsigned int opcode : 4;
	unsigned int qr : 1;

	unsigned int rcode : 4;
	unsigned int z : 3;
	unsigned int ra : 1;
#else
	unsigned int qr : 1;
	unsigned int opcode : 4;
	unsigned int aa : 1;
	unsigned int tc : 1;
	unsigned int rd : 1;
	unsigned int ra : 1;
	unsigned int z : 3;
	unsigned int rcode : 4;
#endif

	unsigned int qdcount : 16;
	unsigned int ancount : 16;
	unsigned int nscount : 16;
	unsigned int arcount : 16;
};

int dns_query(char *name, int len);
unsigned long dns_read(int sok);
int dns_parse_record(char *buf, char **ptr);

#endif
